local se = require "samp.events"

local balloons = {
	[19332] = { 003, 003 }, -- Red
	[19333] = { 152, 152 }, -- Blue
	[19334] = { 001, 001 }, -- White
	[19335] = { 152, 006 }, -- Blue & Yellow
	[19336] = { 126, 001 }, -- Pink & White
	[19337] = { 243, 006 }, -- Green & Yellow
	[19338] = { 243, 003 }, -- Green and Red
	[16801] = { 222, 006 }, -- Magic 1 (Lava)
	[16802] = { 154, 166 }, -- Magic 2 (Antique)
	[16803] = { 163, 049 },	-- Magic 3 (Air)
	[16804] = { 194, 142 }, -- Magic 4 (Alien)
	[16805] = { 226, 241 }, -- Magic 5 (Toxic)
	[16806] = { 162, 135 }, -- Magic 6 (Electro)
	[16807] = { 233, 233 }	-- Magic 7 (Purple)
	[6723] = { 001, 001 }, -- 
}

function main()
	repeat wait(0) until isSampAvailable()
	local result, samp = loadDynamicLibrary("samp.dll")
	if result then
		local offset = getGameGlobal(707) <= 21 and 0xB0DE0 or 0xB6AA0
		writeMemory(samp + offset, 0x02, 0xC390, true)
	end
	wait(-1)
end

function se.onCreate3DText(id, color, pos, dist, wall, vehicle, player, text)
	if string.match(text, "[   ]") and color == -763941633 then
		pos.x, pos.y, pos.z = 0, 0, 0
		text = "[   ]"
		color = 0xFFFFFF30
		return { id, color, pos, dist, wall, vehicle, player, text }
	end
end

function se.onCreateObject(id, data)
	if data.attachToVehicleId ~= 0xFFFF then
		local result, car = sampGetCarHandleBySampVehicleId(data.attachToVehicleId)
		if result and isCarModel(car, 487) then
			local model = data.modelId
			if model == 2923 or model == 19131 then
				return false
			else
				for id, color in pairs(balloons) do
					if model == id then
						linkVehicleToInterior(data.attachToVehicleId, 0)
						changeCarColour(car, color[1], color[2])
						return false
					end
				end
			end
		end
	end
end

function linkVehicleToInterior(vehicleId, interior)
	local BS = raknetNewBitStream()
	raknetBitStreamWriteInt16(BS, vehicleId)
	raknetBitStreamWriteInt8(BS, interior)
	raknetEmulRpcReceiveBitStream(65, BS)
	raknetDeleteBitStream(BS)
end